import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class Bush extends Fractal
{
	int minLen;
	int orgx,orgy;
	double ang=0.5;
	boolean flag=true;
	Image bimg;
	Graphics gr,g;
	Thread t=null;
	
	Bush(FractalMagic f)
	{	super(f);
	}	
	void initialize()
	{
		setFractalName("Bush Tree Fractal");
		bimg=this.createImage(800,600);
		gr=bimg.getGraphics();
		g=this.getGraphics();
	}
	public void run()
	{	
		boolean prevflag=flag;
		
		
	  while(true)				//only way to get out is thru Quit button
	  {
		orgx=300;
		orgy=100;
		for(ang=0.5;ang<3.5;ang=ang+0.4)
		{	
			bushtree(40,ang,300,400,12);
			//repaint();
			while(prevflag==flag)
			{	try {Thread.currentThread().sleep(10);}
				catch (InterruptedException e) { }	
			}
			prevflag=flag;
		}
	  }
	}
	void bushtree(int n,double a,int x,int y,int t)
	{
		int i;
		double aa=a,r,gg,b;
		for(i=0;i<t;i++)
		{
			r=Math.random();
			gg=Math.random();
			b=Math.random();
			gr.setColor(new Color((float)(r),(float)(gg),(float)(b)));//for image
			g.setColor(new Color((float)(r),(float)(gg),(float)(b)));//for screen
			orgx=x;orgy=y;
			godir(n,a);
			x=orgx;	y=orgy;
			if(n>3)
				bushtree(n/3,a-0.3,x,y,t-i);
			a=a-aa/20;
		}
	}
	void godir(int n,double ang)
	{
		int xinc,yinc;
		xinc=(int)(n*Math.cos(ang));
		yinc=(int)(n*Math.sin(ang));
		gr.drawLine(orgx,orgy,orgx+xinc,orgy-yinc);
		g.drawLine(orgx,orgy,orgx+xinc,orgy-yinc);
		orgx=orgx+xinc;
		orgy=orgy-yinc;
	}
	/*public void paint(Graphics g)
	{
		if(bimg!=null)g.drawImage(bimg,0,0,this);
	}*/
	public boolean mouseDown (Event e, int x, int y)
	{	flag=!flag;	
		return true;
	}
	void tuneSettings()
	{			}
	void saveToFile(){	save(bimg);	}
	void quit(){	this.dispose();main.setVisible(true);}	
	void resetDefaults()
	{
		orgx=300;
		orgy=100;
		ang=0;
		bimg=this.createImage(800,600);
		gr=bimg.getGraphics();		
	}
}