//fm
//import needed packages
import java.awt.*;
import java.awt.event.*;
//This is the main controller class
public class FractalMagic extends Frame implements ActionListener
{
	
	//Frame frame;
	Mandelbrot mf;
	Sierp ifs;
	Jpark jp;
	Bush bt;
	Tree tr;
	 
	Button bmandel,bsierp,bquit,bjpark,bbushtree,btree;
	Label mainLbl;
	String msg="No action";
	
	public static void main( String argv[])
	{
		FractalMagic fm =new FractalMagic();
		fm.setBounds(50,20,650,480);
		fm.setVisible(true);
		fm.init();
	}
	//initialize vars and create buttons.
	void init()
	{
		
		addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){dispose();System.exit(0);}}
		);
		
		
		//set the layout so that all buttons are at absolute pos
		setLayout(null);
		
		//create the buttons required to choose the fractal
		//to be generated
		mainLbl=new Label("FRACTAL MAGIC",Label.CENTER);
		bmandel=new Button("Mandelbrot");
		bsierp=new Button("Sierpensky");
		bquit=new Button("Quit");
		bjpark=new Button("Jurassic Park");
		bbushtree=new Button("Bush Tree");
		btree=new Button("Tree fractal");
		
		add(mainLbl);
		add(bmandel);
		add(bsierp);
		add(bquit);
		add(bjpark);
		add(bbushtree);
		add(btree);
		
		mainLbl.setFont(new Font("ComicSans",Font.BOLD,20));
		mainLbl.setForeground(Color.blue);
		mainLbl.setBackground(Color.pink);
		
		bmandel.setForeground(Color.blue);
		bsierp.setForeground(Color.blue);
		bquit.setForeground(Color.blue);
		bjpark.setForeground(Color.blue);
		bbushtree.setForeground(Color.blue);
		btree.setForeground(Color.blue);
		
		bmandel.setBackground(Color.yellow);
		bsierp.setBackground(Color.yellow);
		bquit.setBackground(Color.yellow);
		bjpark.setBackground(Color.yellow);
		bbushtree.setBackground(Color.yellow);
		btree.setBackground(Color.yellow);
		
		mainLbl.setBounds(50,100,550,100);
		int butx=50,buty=300,l=150,h=50;
		int xpos=butx,ypos=buty;
		bmandel.setBounds(xpos,ypos,l,h);xpos+=l+50;
		bsierp.setBounds(xpos,ypos,l,h);xpos+=l+50;
		bjpark.setBounds(xpos,ypos,l,h);xpos+=l+50;
		
		xpos=butx;ypos=buty+h+40;
		bbushtree.setBounds(xpos,ypos,l,h);xpos+=l+50;
		btree.setBounds(xpos,ypos,l,h);	xpos+=l+50;
		bquit.setBounds(xpos,ypos,l,h);	xpos+=l+50;
		
		
		bmandel.addActionListener(this);
		bsierp.addActionListener(this);
		bquit.addActionListener(this);
		bjpark.addActionListener(this);
		bbushtree.addActionListener(this);
		btree.addActionListener(this);
	}
	//action to be performed on mouse click
	public void actionPerformed(ActionEvent ae)
	{
		
		String str=ae.getActionCommand();
		if(str.equals("Mandelbrot"))
		{	
			mf=new Mandelbrot(this);
			mf.Size(50,20,650,550);
			mf.setBackground(Color.cyan);
			mf.setVisible(true);
			this.setVisible(false);
			mf.initialize();
			mf.t= new Thread(mf,"mandelbrot");
			mf.t.start();
		}
		else if(str.equals("Sierpensky"))
		{	
			msg="You pressed"+str;
			ifs=new Sierp(this);
			ifs.Size(50,20,650,550);
			ifs.setBackground(Color.cyan);
			ifs.setVisible(true);
			this.setVisible(false);
			ifs.initialize();
			ifs.t= new Thread(ifs,"Ifs");
			ifs.t.start();
		}
		else if(str.equals("Jurassic Park"))
		{
			jp=new Jpark(this);
			jp.Size(50,20,650,550);
			jp.setBackground(Color.cyan);
			jp.setVisible(true);
			this.setVisible(false);
			jp.initialize();
			jp.t= new Thread(jp,"Jurassic Park");
			jp.t.start();
		}
		else if(str.equals("Bush Tree"))
		{	
			bt=new Bush(this);
			bt.Size(50,20,650,550);
			bt.setBackground(Color.cyan);
			bt.setVisible(true);
			this.setVisible(false);
			bt.initialize();
			bt.t= new Thread(bt,"Bushtree");
			bt.t.start();
		}
		else if(str.equals("Tree fractal"))
		{	
			tr=new Tree(this);
			tr.Size(50,20,650,550);
			tr.setBackground(Color.cyan);
			tr.setVisible(true);
			this.setVisible(false);
			tr.initialize();
			tr.t= new Thread(tr,"Bushtree");
			tr.t.start();;
		}
		else if(str.equals("Quit"))
		{	dispose();
			System.exit(0);
		}
	}//end actionPreformed
}//end fractalMagic class



